using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace GISAppUsingMapWindow
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();
        }

        private void frmMain_Load(object sender, EventArgs e)
        {
            loadGISData();
            mapMain.CursorMode = MapWinGIS.tkCursorMode.cmNone;
        }

        // load gis data (shape file)
        private void loadGISData()
        {
            int iCtrShape;

            MapWinGIS.Shapefile sfBatas = new MapWinGIS.Shapefile();
            sfBatas.Open("C:\\temp\\OutputDir\\BATAS.shp", sfBatas.GlobalCallback);
            mapMain.AddLayer(sfBatas, true);

            for (iCtrShape = 0; iCtrShape < sfBatas.NumShapes; iCtrShape++)
            {
                showLabel(sfBatas.QuickPoint(iCtrShape, sfBatas.get_numPoints(iCtrShape) / 2).x, sfBatas.QuickPoint(iCtrShape, sfBatas.get_numPoints(0) / 2).y, iCtrShape);
            }
        }

        // show shape label
        private void showLabel(double dX, double dY, int iCtrShape)
        {
            string sTextLabel;
            UInt32 iClrLabel;
            int iID;

            iClrLabel = Convert.ToUInt32(Color.Black.ToArgb() & 0x00FFFFFF);

            iID = iCtrShape + 1;
            sTextLabel = iID.ToString();
            mapMain.AddLabel(0, sTextLabel, iClrLabel, dX, dY, MapWinGIS.tkHJustification.hjCenter);
        }

        private void btnZoomIn_Click(object sender, EventArgs e)
        {
            mapMain.CursorMode = MapWinGIS.tkCursorMode.cmZoomIn;
        }

        private void btnZoomOut_Click(object sender, EventArgs e)
        {
            mapMain.CursorMode = MapWinGIS.tkCursorMode.cmZoomOut;
        }

        private void btnPan_Click(object sender, EventArgs e)
        {
            mapMain.CursorMode = MapWinGIS.tkCursorMode.cmPan;
        }

        private void btnFullExtent_Click(object sender, EventArgs e)
        {
            mapMain.ZoomToMaxExtents();
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Dispose();
        }

        private void btnFillColor_Click(object sender, EventArgs e)
        {
            UInt32 iLineColor;
            Single fLineWidth;
            MapWinGIS.tkLineStipple lsLineStipple;

            // display setting for line
            mapMain.set_ShapeLayerDrawLine(0,true);
            iLineColor = Convert.ToUInt32(Color.DarkBlue.ToArgb() & 0x00FFFFFF);
            fLineWidth = Convert.ToSingle(2);
            lsLineStipple = MapWinGIS.tkLineStipple.lsDashDotDash;
            mapMain.set_ShapeLayerLineColor(0, iLineColor);
            mapMain.set_ShapeLayerLineWidth(0, fLineWidth);
            mapMain.set_ShapeLayerLineStipple(0, lsLineStipple);

        }

        private void btnClrSch_Click(object sender, EventArgs e)
        {
            int iCtrShape;
            int iID;
            int iNumOfShp;

            iNumOfShp = 3;

            // randering different shape of a layer
            for (iCtrShape = 0; iCtrShape <= iNumOfShp; iCtrShape++)
            {
                iID = iCtrShape + 1;
                if (iID == 1) mapMain.set_ShapeFillColor(0, iCtrShape, Convert.ToUInt32(Color.Red.ToArgb() & 0x00FFFFFF));
                if (iID == 2) mapMain.set_ShapeFillColor(0, iCtrShape, Convert.ToUInt32(Color.Blue.ToArgb() & 0x00FFFFFF));
                if (iID == 3) mapMain.set_ShapeFillColor(0, iCtrShape, Convert.ToUInt32(Color.Black.ToArgb() & 0x00FFFFFF));
            }
        }

        private void btnLabel_Click(object sender, EventArgs e)
        {
            mapMain.ClearLabels(0);
        }
    }
}